package es.verdnatura.di

import es.verdnatura.presentation.view.feature.ajustes.fragment.AjustesViewModel
import es.verdnatura.presentation.view.feature.articulo.fragment.ItemCardViewModel
import es.verdnatura.presentation.view.feature.boxPicking.BoxPickingViewModel
import es.verdnatura.presentation.view.feature.buffer.fragment.BufferFragmentViewModel
import es.verdnatura.presentation.view.feature.buscaritem.fragment.BuscarItemViewModel
import es.verdnatura.presentation.view.feature.category.ChangeCategoryViewModel
import es.verdnatura.presentation.view.feature.claim.fragment.ubication.ClaimViewModel
import es.verdnatura.presentation.view.feature.collection.fragment.CollectionViewModel
import es.verdnatura.presentation.view.feature.controlvehiculo.fragment.ControlVehiculoViewModel
import es.verdnatura.presentation.view.feature.delivery.viewmodels.DeliveryViewModel
import es.verdnatura.presentation.view.feature.diadeventa.fragment.DayOfSaleViewModel
import es.verdnatura.presentation.view.feature.historicoarticulo.fragment.HistoricoArticuloViewModel
import es.verdnatura.presentation.view.feature.historicoshelving.fragment.ItemShelvingLogViewModel
import es.verdnatura.presentation.view.feature.historicoshelvinglog.fragment.ShelvingLogViewModel
import es.verdnatura.presentation.view.feature.historicovehiculo.fragment.HistoricoVehiculoViewModel
import es.verdnatura.presentation.view.feature.inventario.fragment.InventaryViewModel
import es.verdnatura.presentation.view.feature.login.fragment.LoginViewModel
import es.verdnatura.presentation.view.feature.packaging.fragment.SupplierViewModel
import es.verdnatura.presentation.view.feature.packingHolland.fragment.PackingHollandViewModel
import es.verdnatura.presentation.view.feature.paletizador.fragment.CmrExpeditionPalletViewModel
import es.verdnatura.presentation.view.feature.paletizador.fragment.ExpeditionPalletDetailViewModel
import es.verdnatura.presentation.view.feature.paletizador.fragment.ExpeditionPalletViewModel
import es.verdnatura.presentation.view.feature.paletizador.fragment.ExpeditionScanSorterViewModel
import es.verdnatura.presentation.view.feature.paletizador.fragment.ExpeditionScanViewModel
import es.verdnatura.presentation.view.feature.paletizador.fragment.ExpeditionStateViewModel
import es.verdnatura.presentation.view.feature.paletizador.fragment.ExpeditionTruckListViewModel
import es.verdnatura.presentation.view.feature.paletizador.fragment.PalletScanViewModel
import es.verdnatura.presentation.view.feature.parking.fragment.ParkingViewModel
import es.verdnatura.presentation.view.feature.pasillero.fragment.PasilleroViewModel
import es.verdnatura.presentation.view.feature.presacador.fragment.PreSacadorViewModel
import es.verdnatura.presentation.view.feature.qr.QrFragmentViewModel
import es.verdnatura.presentation.view.feature.roadmap.fragment.RoadMapListViewModel
import es.verdnatura.presentation.view.feature.sacador.fragment.SacadorViewModel
import es.verdnatura.presentation.view.feature.sacador.fragment.showticket.ShowTicketViewModel
import es.verdnatura.presentation.view.feature.ticket.fragment.TicketViewModel
import es.verdnatura.presentation.view.feature.ubicador.fragment.AutomaticAddItemViewModel
import es.verdnatura.presentation.view.feature.ubicador.fragment.UbicadorViewModel
import org.koin.android.ext.koin.androidContext
import org.koin.androidx.viewmodel.dsl.viewModel
import org.koin.dsl.module

val viewModelModule = module {

    /* viewModel {
         WorkermistakeViewModel()
     }*/

    // Login
    viewModel {
        LoginViewModel(androidContext())
    }

    // Pasilleros
    viewModel {
        PasilleroViewModel(androidContext())
    }
    //Pasilleros Dia de venta
    viewModel {
        DayOfSaleViewModel(androidContext())
    }

    // Pasilleros / Item Card
    viewModel {
        ItemCardViewModel(androidContext())
    }

    // Pasilleros / Item Card / Historico
    viewModel {
        HistoricoArticuloViewModel(androidContext())
    }

    // Pasilleros / Buscar Item
    viewModel {
        BuscarItemViewModel(androidContext())
    }

    // Pasilleros / Buscar Item 2

    viewModel {
        ShowTicketViewModel(androidContext())
    }

    // Pasilleros / Inventario
    viewModel {
        InventaryViewModel(androidContext())
    }

    // Ubicador
    viewModel {
        UbicadorViewModel(androidContext())
    }

    // Ubicador // Automatic
    viewModel {
        AutomaticAddItemViewModel(androidContext())
    }

    // Ajustes
    viewModel {
        AjustesViewModel(androidContext())
    }

    // PALETIZADOR

    viewModel {
        ExpeditionScanSorterViewModel(androidContext())
    }


    viewModel {
        CmrExpeditionPalletViewModel(androidContext())
    }

    viewModel {
        BufferFragmentViewModel(androidContext())
    }

    viewModel {
        ExpeditionStateViewModel(androidContext())
    }

    viewModel {
        ExpeditionTruckListViewModel(androidContext())
    }

    viewModel {
        ExpeditionPalletViewModel(androidContext())
    }

    viewModel {
        ExpeditionPalletDetailViewModel(androidContext())
    }

    viewModel {
        ExpeditionScanViewModel(androidContext())
    }
    viewModel {
        QrFragmentViewModel(androidContext())
    }

    // SACADOR
    viewModel {
        SacadorViewModel(androidContext())
    }

    viewModel {
        CollectionViewModel(androidContext())
    }

    viewModel {
        ParkingViewModel(androidContext())
    }

    viewModel {
        PreSacadorViewModel(androidContext())
    }

    viewModel {
        ControlVehiculoViewModel(androidContext())
    }

    viewModel {
        HistoricoVehiculoViewModel(androidContext())
    }

    viewModel {
        ItemShelvingLogViewModel(androidContext())
    }
    viewModel {
        ShelvingLogViewModel(androidContext())
    }
    viewModel {
        ClaimViewModel(androidContext())
    }

    viewModel {
        PalletScanViewModel(androidContext())
    }
    viewModel {
        SupplierViewModel(androidContext())
    }
    viewModel {
        DeliveryViewModel(androidContext())
    }

    viewModel {
        PackingHollandViewModel(androidContext())
    }

    viewModel {
        TicketViewModel(androidContext())
    }
    viewModel {
        RoadMapListViewModel(androidContext())
    }
    viewModel {
        ChangeCategoryViewModel(androidContext())
    }
    viewModel {
        BoxPickingViewModel(androidContext())
    }
}